﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Static StrConstant k_fullpackageFolder = "root:Packages:imgT"
Static StrConstant k_pvfolder = "imgT_processvariables"
Static StrConstant k_fullpvfolder = "root:Packages:imgT:imgT_processvariables"
Static StrConstant k_fullpanel = "imgT_display#imgT_panel"

// uncomment to debug
//#define DEBUG

#ifndef DEBUG
#pragma hide=1
#endif

// ***
// STRUCTURES

// background settings
Static Structure S_BackgroundParams
	variable plorder
	variable mask
endStructure

Function Sf_GetBackgroundParams(sbg)
	STRUCT S_BackgroundParams &sbg
	
	ControlInfo/W=$k_fullpanel setvarPlOrder_tab1
	sbg.plorder = v_value
	ControlInfo/W=$k_fullpanel popupBckMask_tab1
	sbg.mask = v_value
	
	return 0
end

// structure to store process variables
Structure S_ProcessVariables
	variable xyhow
	// image xy pixel size (meters)
	variable xympixel
	variable xylmpixel
	// image width (meters)
	variable xyiwidth
	variable xyliwidth
EndStructure

Function Sf_SaveProcessVariables(spv,all)
	STRUCT S_ProcessVariables &spv
	variable all

	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string iwf	
	
	DFREF cwd = GetDataFolderDFR()

	// save local
	// (clumsy but future proof)
	iwf = "root:" + cwdfolder	
	SetDataFolder $iwf	
	NewDataFolder/O/S $k_pvfolder
	variable/G xyhow, xympixel, xylmpixel, xyiwidth, xyliwidth
	SetDataFolder cwd
	iwf += ":" + k_pvfolder
	NVAR/SDFR=$iwf xyhow, xympixel, xylmpixel, xyiwidth, xyliwidth
	xyhow = spv.xyhow
	xympixel = spv.xympixel
	xylmpixel = spv.xylmpixel
	xyiwidth = spv.xyiwidth
	xyliwidth = spv.xyliwidth
	
	if (all)
		// validate/create globals anew each time
		// (clumsy but future proof)
		SetDataFolder pf
		NewDataFolder/O/S $k_pvfolder
		variable/G xyhow, xympixel, xylmpixel, xyiwidth, xyliwidth
		SetDataFolder cwd

		iwf = k_fullpackageFolder + ":" + k_pvfolder
		NVAR/SDFR=$iwf xyhow, xympixel, xylmpixel, xyiwidth, xyliwidth
		xyhow = spv.xyhow
		xympixel = spv.xympixel
		xylmpixel = spv.xylmpixel
		xyiwidth = spv.xyiwidth
		xyliwidth = spv.xyliwidth
	endif
	
	return 0
end

Function Sf_GetProcessVariables(spv)
	STRUCT S_ProcessVariables &spv

	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	string iwf
	
	// check local
	iwf = "root:" + cwdfolder + ":" + k_pvfolder
	if (DataFolderExists(iwf))
		NVAR/SDFR=$iwf xyhow, xympixel, xylmpixel, xyiwidth, xyliwidth
		spv.xyhow = xyhow
		spv.xympixel = xympixel
		spv.xylmpixel = xylmpixel
		spv.xyiwidth = xyiwidth
		spv.xyliwidth = xyliwidth
		return 0
	endif
	
	// check global
	if (DataFolderExists(k_fullpvfolder))
		NVAR/SDFR=$k_fullpvfolder xyhow, xympixel, xylmpixel, xyiwidth, xyliwidth
		spv.xyhow = xyhow
		spv.xympixel = xympixel
		spv.xylmpixel = xylmpixel
		spv.xyiwidth = xyiwidth
		spv.xyliwidth = xyliwidth
		return 1
	endif
	
	// neither local or global
	return -1
end

// ***
// HELPER FUNCTIONS

// list of background methods
Function/S f_BckMasks()

	string rtstr = "None;"
	
	STRUCT S_MarqueeCoordinates mq
	Sf_GetMCCoordinates(mq)

	if (mq.hasmarquee == 1)
		rtstr += "X<[ ]>X; [>x<] ;"
	endif
	
	return rtstr
end
//
//// list of background mask options
//Function/S f_BckMaskValues()
//
//	string rtstr
//	
//	STRUCT S_MarqueeCoordinates mq
//	Sf_GetMCCoordinates(mq)
//	
//	if (mq.hasmarquee == 1)
//		variable bd = (2^f_ImageBitDepth()) - 1
//		sprintf rtstr,"No Change;0;%d;", bd
//	else
//		rtstr = "No Change;"
//	endif
//	
//	return rtstr
//end
// ***
// TAB

// draw tab1 - calibrate
Function disp_Tab1Draw(pwidth,pheight, ptabpos)
	variable pwidth, pheight, ptabpos

	variable tvoffset = ptabpos + 25
	
	TabControl tab_main, value=1, userdata(ptab)="1"
	
	TitleBox calibrate_tab1,pos={12,tvoffset},size={84,22},title="Calibrate XY"
	TitleBox calibrate_tab1,fSize=18,frame=0,fStyle=1,disable=1

	tvoffset += 25
	
	PopupMenu popupmethodxy_tab1,pos={20,tvoffset},size={113,23},title="How"
	PopupMenu popupmethodxy_tab1,mode=1,popvalue="pixel size",value= #"\"pixel size;image width;\""
	PopupMenu popupmethodxy_tab1,fSize=14,disable=1,proc=X_PopMenuProc
	
	SetVariable psizem_tab1, pos={12+140,tvoffset},size={90,16},title="[m]",format="%1.4f"
	SetVariable psizem_tab1, fSize=12,value=_NUM:1, limits={1,10,0.1}, disable=1
	SetVariable psizelm_tab1, pos={12+240,tvoffset-2},size={70,16},title="10\Sn\M"
	SetVariable psizelm_tab1, fSize=12,value=_NUM:1, limits={-10,10,1}, disable=1
	
	Button buttonSetXY_tab1,pos={pwidth-85,tvoffset-2},size={75,25},proc=X_ButtonProc,title="Apply"
	Button buttonSetXY_tab1,fSize=14,disable=1
	
	Button buttonclearlocalscale_tab1,pos={pwidth-200,tvoffset+25},size={76,16},title="Clear Local"
	Button buttonclearlocalscale_tab1,fSize=10,proc=X_ButtonProc,disable=1
	
	CheckBox checkxyglobal_tab1,pos={pwidth-90,tvoffset+25},size={76,16},title="save as global"
	CheckBox checkxyglobal_tab1,fSize=10,value=0, disable=1
	
	// background
	
	tvoffset += 40
		
	TitleBox background_tab1,pos={12,tvoffset},size={84,22},title="Remove Background"
	TitleBox background_tab1,fSize=18,frame=0,fStyle=1,disable=1
	
	tvoffset += 25
	
	SetVariable setvarplorder_tab1,pos={20,tvoffset},size={115,23},title="Plane Order",fSize=14
	SetVariable setvarplorder_tab1,limits={1,4,1},value=_NUM:1, disable=1
	
	PopupMenu popupBckMask_tab1,pos={140,tvoffset},size={120,23},title="Mask"
	PopupMenu popupBckMask_tab1,mode=1,popvalue="None",value=f_BckMasks(),fSize=14,disable=1

	Button buttonRemoveBckg_tab1,pos={pwidth-85,tvoffset-2},size={75,25},proc=X_ButtonProc,title="Apply"
	Button buttonRemoveBckg_tab1,fSize=14,disable=1
//
//	tvoffset += 25
//			
//	CheckBox checkbgtoall_tab1,pos={20,tvoffset},size={76,16},title="apply to stack"
//	CheckBox checkbgtoall_tab1,fSize=10,value=0, disable=1
//	
//	CheckBox checkbgglobal_tab1,pos={pwidth-90,tvoffset},size={76,16},title="save as global"
//	CheckBox checkbgglobal_tab1,fSize=10,value=0, disable=1

	return 0
end

// ***
// ACTIONS

// clear local scale
Function T1_ClearLocalScale()
	
	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string iwf	
	iwf = "root:" + cwdfolder + ":" + k_pvfolder

	KillDataFolder/Z $iwf

	return 0
end

// set xy method
Function T1_SetXYMethod(how)
	variable how
	
//	PopupMenu mrulera_tab1, win=$k_fullpanel, disable = 1
	switch(how)
		case 4:	// ruler length
			PopupMenu mrulera_tab1, win=$k_fullpanel, disable = 0
			break
	endswitch
	return 0
end

// set the xy calibration
Function T1_SetXY()
	
	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	string swf = "root:" + cwdfolder
	wave/SDFR=$swf cwave = $cwfile
	
	variable iwpx, iw, asglobal

	STRUCT S_ProcessVariables spv

	// get values
	ControlInfo/W=$k_fullpanel popupmethodxy_tab1
	spv.xyhow = v_value
	
	switch(v_value)
		case 1:	// pixel size
			ControlInfo/W=$k_fullpanel psizem_tab1
			spv.xympixel = v_value
			ControlInfo/W=$k_fullpanel psizelm_tab1
			spv.xylmpixel = v_value
			spv.xyiwidth = 0
			break
		case 2:	// image width
			spv.xympixel = 0
			spv.xylmpixel = v_value
			ControlInfo/W=$k_fullpanel psizem_tab1
			spv.xyiwidth = v_value
			ControlInfo/W=$k_fullpanel psizelm_tab1
			spv.xyliwidth = v_value
			break
	endswitch
		
	ControlInfo/W=$k_fullpanel checkxyglobal_tab1
	asglobal = v_value

	// save values
	Sf_SaveProcessVariables(spv,asglobal)
	
	return 0
end

// remove background
Function T1_RemoveBackground()
	
	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	string wdf = "root:" + cwdfolder
	string sfile, wfile
	variable cplane = f_PlaneNumber(), bd = f_ImageBitDepth()
	variable imax=(2^8)-1
	variable nimgs, imin=0, po, mask
	
	// avoid background removal on a background
	// set existence of background
	if (f_isBackground())
		sfile = ReplaceString("_bg",cwfile,"")
		wave/SDFR=$wdf simg = $sfile
		wfile = sfile + "_bg"
	else
		wave/SDFR=$wdf simg = $cwfile
		wfile = cwfile + "_bg"
		sfile = cwfile
	endif

	STRUCT S_BackgroundParams sbg
	Sf_GetBackgroundParams(sbg)
	
	po = sbg.plorder
	mask = sbg.mask
	
	// remove the background
	
	DFREF cdf = GetDataFolderDFR()
	SetDataFolder $wdf

	// get current image
	if (f_isStack())
		MatrixOP/O $wfile = simg[][][cplane]
		nimgs = DimSize($sfile,2)
	else
		duplicate/O simg $wfile
		nimgs = 1
	endif
	
	wave bimg = $wfile
	
	STRUCT S_MarqueeCoordinates mq
	Sf_GetMCCoordinates(mq)

	// redimension and set RoI/mask
	Redimension/S bimg	
	switch(mask)
		case 1:		// no mask
			ImageRemoveBackground/P=(po)/W/O bimg
			break
		case 2:		// mask outside
			Duplicate/FREE bimg roiimg
			Redimension/B/U roiimg
			roiimg = 64
			roiimg[mq.pgleft,mq.pgright][mq.pgtop,mq.pgbottom] = 1
			ImageRemoveBackground/P=(po)/W/O/R=roiimg bimg
			break
		case 3:		// mask inside
			Duplicate/FREE bimg roiimg
			Redimension/B/U roiimg
			roiimg = 1
			roiimg[mq.pgleft,mq.pgright][mq.pgtop,mq.pgbottom] = 64
			ImageRemoveBackground/P=(po)/W/O/R=roiimg bimg
			break
	endswitch
#ifdef DEBUG	
	print "before"
	WaveStats/M=1 bimg
#else
	WaveStats/M=1/Q bimg
#endif
	bimg -= V_min
	bimg *= (imax - imin)/(V_max - V_min)
#ifdef DEBUG
	print "after"
	WaveStats/M=1 bimg
#endif
	Redimension/B/U bimg
#ifdef DEBUG
	print "done"
	WaveStats/M=1 bimg
#endif
	
	SetDataFolder cdf

	return 0
end