﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Static StrConstant k_fullpackageFolder = "root:Packages:imgT"

Static StrConstant k_panelName = "imgT_panel"
Static StrConstant k_fullpanel = "imgT_display#imgT_panel"
Static StrConstant k_fullhgraphs = "imgT_display#Histograms#imgT_histograms"
Static StrConstant k_imgDisplay = "imgT_display"
Static StrConstant k_fullhpanel = "imgT_display#Histograms"
Static Constant gwidth = 640

// uncomment to debug
//#define DEBUG

#ifndef DEBUG
#pragma hide=1
#endif

// ***
// PANEL CONTROL FUNCTIONS

// tab procedure
Function X_TabProc(tca) : TabControl
	STRUCT WMTabControlAction &tca

	variable ctab
	string tablist, ptab
	
	switch( tca.eventCode )
		case 2: // mouse up
			ctab = tca.tab

#ifndef DEBUG
			// no switching to other tabs until an image is loaded
			if (!f_ImageLoaded())
				TabControl tab_main, win=$k_fullpanel, value = 0
				return 0
			endif
#endif
			// do nothing if the same tab
			ptab = GetUserData(k_fullpanel,"tab_main","ptab")
			if (str2num(ptab)==ctab)
				return 0
			endif
			
			// switch tabs
			disp_SwitchTab(ptab,ctab)
			
			break
	endswitch
	
	return 0
end

// button control procedure
Function X_ButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	
	variable nimgs, brkout, cplane
	variable method, level
	
	switch( ba.eventCode )
		case 2: // mouse up
			// click code here
			strswitch(ba.ctrlName)
				case "buttonLoad_tab0":
					nimgs = f_NImagesLoaded()
					ControlInfo/W=$k_fullpanel popupload_tab0
					switch(v_value)
						case 1:
							brkout = T0_LoadOneTIFFimg()
							break
						case 2:
							brkout = T0_LoadMultipleTIFFimgs()
							break
						case 3:
							brkout = T0_LoadaFolder()
							break
						case 4:
							brkout = T0_LoadStackTiffimgs()
							break
					endswitch
					if (brkout == -1)
						return -1
					endif
					// replace image if this is the first
					if (nimgs == 0)
						TM_StepThruImages(0)
						TM_UpdateContactPrint()
						disp_InitializeTabMenus(100)
					else
						TM_StepThruImages(0)
						disp_InitializeTabMenus(0)
					endif
					ControlUpdate/A/W=$k_fullpanel
					break
				case "buttonleft_tabM":
					disp_SplitWindow(0)
					TM_StepThruImages(-1)	
					disp_UpdatePanelControls(-1)
					ControlInfo/W=$k_fullpanel tab_main
					disp_UpdatePanelControls(v_value)
					TM_UpdateContactPrint()
					break
				case "buttonright_tabM":
					disp_SplitWindow(0)
					TM_StepThruImages(1)
					disp_UpdatePanelControls(-1)
					ControlInfo/W=$k_fullpanel tab_main
					disp_UpdatePanelControls(v_value)
					TM_UpdateContactPrint()
					break
				case "buttonRedoH_tabM":
					disp_AppendHistograms(1)
					TM_UpdateContactPrint()
					break
				case "buttonDoCPrint_tabM":
					TM_CreateContactPrintLayout()
					break
				case "buttonClearAll_tabM":
					TM_ClearAllContactPrintImages()
					break
				case "buttonSetXY_tab1":
					T1_SetXY()
					disp_UpdatePanelControls(1)
					break
				case "buttonResetIRange_CB":
					ChangeImageBitDepth(-1,0)
					ChangeImageBitDepth(1,1)
					Slider sliderIMin_CB, win=$k_imgDisplay, value=0
					Slider sliderIMax_CB, win=$k_imgDisplay, value=1
					break
				case "buttonclearlocalscale_tab1":
					T1_ClearLocalScale()
					disp_UpdatePanelControls(1)
					break
				case "buttondoMovie_CB":
					ControlInfo/W=$k_imgDisplay setvarsleep_CB
					TM_PlayStack(v_value)
					break
				case "buttonRemoveBckg_tab1":
					T1_RemoveBackground()
					disp_UpdatePanelControls(-1)
					disp_UpdatePanelControls(1)
					break
				case "buttondoThreshold_tab2":
					ControlInfo/W=$k_fullPanel popupThresMethod_tab2
					method = v_value-1
					ControlInfo/W=$k_fullPanel setvarThresLevel_tab2
					level = v_value
					ControlInfo/W=$k_fullPanel checkOTPlane_tab2
					if (v_value)
						cplane = f_PlaneNumber()
						T2_DoThreshold(method,level,plane=cplane)
					else
						T2_DoThreshold(method,level)
					endif
					disp_UpdatePanelControls(-1)
					disp_UpdatePanelControls(2)
					break
			endswitch
		case -1: // control being killed
			break
	endswitch
	
	return 0
end

// slider procedure
Function X_SliderProc(sa) : SliderControl
	STRUCT WMSliderAction &sa

	variable bd
	
	switch( sa.eventCode )
		case -3: // Control received keyboard focus
		case -2: // Control lost keyboard focus
		case -1: // Control being killed
			break
		default:
			strswitch(sa.ctrlName)
				case "slidermagdhist_tabM":
					if( sa.eventCode & 1 ) // value set
						ScaleDHistogram(sa.curval)
					endif
					break
				case "sliderIMin_CB":
					if( sa.eventCode & 1 ) // value set
						ChangeImageBitDepth(-1,sa.curval)
					endif
					break
				case "sliderIMax_CB":
					if( sa.eventCode & 1 ) // value set
						ChangeImageBitDepth(1,sa.curval)
					endif
					break
			break
			endswitch
	endswitch

	return 0
end

// popmenu procedure
Function X_PopMenuProc(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2: // mouse up
			if (!X_PopHasChanged(pa))
				return 0
			endif
			strswitch(pa.ctrlName)
				case "popupSBColor_CB":
					ControlInfo/W=$k_imgDisplay popupScaleBar_CB
					if (v_value > 1)
						disp_SetScaleBarColor(pa.popStr)
					else
						PopupMenu popupSBColor_CB, win=$k_imgDisplay, disable=2
					endif
					break
				case "popupScaleBar_CB":
					disp_ShowScaleBar(pa.popNum - 1)
					if (pa.popNum > 1)
						PopupMenu popupSBColor_CB, win=$k_imgDisplay, disable=0
						ControlInfo/W=$k_imgDisplay popupSBColor_CB
						disp_SetScaleBarColor(S_value)				
					else
						PopupMenu popupSBColor_CB, win=$k_imgDisplay, disable=2
					endif
					break
				case "popupload_tab0":
					disp_UpdatePanelControls(0)
					break
				case "popupFolder_tabM":
					// change to a new folder
					disp_SplitWindow(0)
					TM_StepThruImages(0)
					disp_UpdatePanelControls(-1)
					ControlInfo/W=$k_fullpanel tab_main
					disp_UpdatePanelControls(v_value)
					TM_UpdateContactPrint()
					break
				case "popupFile_tabM":
					// change to a new file
					disp_SplitWindow(0)
					ResetImageFile(pa.popStr)
					TM_StepThruImages(0)
					disp_ResetImageFileonPanel()
					disp_UpdatePanelControls(-1)
					ControlInfo/W=$k_fullpanel tab_main
					disp_UpdatePanelControls(v_value)
					TM_UpdateContactPrint()
					break
				case "popupmethodxy_tab1":
					T1_SetXYMethod(pa.popNum)
					disp_UpdatePanelControls(1)
					break
				case "popupThresMethod_tab2":
					disp_UpdatePanelControls(2)
					break
				case "popupSplit_CB":
					disp_SplitWindow(pa.popNum)
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
end

// check whether popup has been changed
// uses userdata
// returns 1 when changed or 0 when not
Function X_PopHasChanged(pa)
	STRUCT WMPopupAction &pa
	
	if (cmpstr(pa.popStr,pa.userdata)==0)
		return 0
	else
		pa.userdata = pa.popStr
		return 1
	endif
end

// checkbox procedure
Function X_CheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			strswitch(cba.ctrlName)
				case "checkshowAxes_CB":
					disp_ShowAxes(cba.checked)
					break
				case "checksethRoI_tabM":
					ControlInfo/W=$k_fullpanel setvarSN_TabM
					GenerateHistograms(cba.checked)
					break
				case "checklockhRoI_tabM":
					LockHistogramRoI(cba.checked)
					disp_UpdatePanelControls(-1)
					break
				case "checkCP_tabM":
					switch(cba.checked)
						case 0:
							TM_RemoveContactPrint()
							break
						case 1:
							TM_StoreasContactPrint()
							break
					endswitch
					TM_UpdateContactPrint()
					break
				case "checkshowhist_tabM":
					disp_ShowHideHistograms(!cba.checked)
					disp_UpdatePanelControls(-1)
					break
				case "checkBW_CB":
					ChangeImageBitDepth(-2,cba.checked)
					break
				case "checkInvert_CB":
					ChangeImageBitDepth(0,cba.checked)
					break
		endswitch
			break
		case -1: // control being killed
			break
	endswitch
	DoWindow/F $k_panelName

	return 0
end

// set variable procedure
Function X_SetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva

	// current only used to take notes to images
	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
			strswitch(sva.ctrlName)
				case "setvarSN_TabM":
					TM_StepThruImages(0,plane=sva.dval)
					TM_UpdateContactPrint()
					break
				case "setvarImgNote_tabM":
					TM_SetImageNote()
					break
				case "mqx0_tabM":
				case "mqy0_tabM":
				case "mqdx_tabM":
				case "mqdy_tabM":
					ResetMQCoordinates()
					break
				case "setvarThresLevel_tab2":
					ControlInfo/W=$k_fullpanel popupThresMethod_tab2
					if (v_value == 1)
						string thlevels = StringFromList(1,SortList(TraceNameList(k_fullhgraphs,";",1)))
						Cursor/W=$k_fullhgraphs A, $thlevels, sva.dval				
					endif
					break
				case "setvarimgMag_CB":
					Modifygraph/W=$k_imgDisplay expand=sva.dval
					MoveSubWindow/W=$k_fullhpanel fnum=(0,0,sva.dval*gwidth,0.25*gwidth)
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
end

// put a date+time stamp
// [dsep] - in date; [tsep] - in time; [dtsep] - between date and time
Function/S f_DateTimeStamp([dsep, tsep, dtsep])
	string dsep, tsep, dtsep
 
	string a, b, c, dstr, tstr, gExp
 
	if (ParamIsDefault(dsep))
		dsep = "-"
	endif
	if (ParamIsDefault(tsep))
		tsep = ":"
	endif
	if (ParamIsDefault(dtsep))
		dtsep = "/"
	endif
 
	gExp = "([0-9]+):([0-9]+)"	
	SplitString/E=(gExp) secs2time(datetime,2), a, b
	tstr = a + tsep + b
 
	gExp = "([0-9]+)/([0-9]+)/([0-9]+)"	
	SplitString/E=(gExp) secs2date(datetime,-1), a, b, c
	dstr = c[2,3] + dsep + b + dsep + a
 
	return (dstr + dtsep +  tstr) 
end

// what is in the split window?

Function/S f_SplitWindowImage()

	string swstr = ""
	swstr = ImageNameList(k_imgDisplay,";")
	
	if (ItemsInList(swstr) > 1)
		swstr = StringFromList(1,SortList(swstr))
	else
		swstr = ""
	endif

	return swstr
end

// a threshold wave exists
Function f_ThresholdExists()

	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	if (f_isThreshold() == 1)
		return 1
	endif
	
	string thfile = f_RootFileName() + "_th"
	string wdf = "root:" + cwdfolder
	wave/SDFR=$wdf/Z thwave = $thfile
	return (waveexists(thwave))
end

// is this a threshold?
Function f_isThreshold()

	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwfile
	
	if (strsearch(cwfile,"_th",0)==-1)
		return 0
	else
		return 1
	endif
end

// is this a background?
Function f_isBackground()

	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwfile
	
	if (strsearch(cwfile,"_bg",0)==-1)
		return 0
	else
		return 1
	endif
end

// is an image loaded?
Function f_ImageLoaded()

	string st = f_LoFolders(cstr="imgT_*")

	if (strlen(st)==0)
		return 0
	else
		return 1
	endif
end

// root file name
Function/S f_RootFileName()

	// globals for package	
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string rfile
	
	rfile = ReplaceString("_th",cwfile,"")
	rfile = ReplaceString("_bg",cwfile,"")
	
	return rfile	
end

// number of image sets loaded
Function f_NImagesLoaded()

	variable ni
	ni = ItemsInList(f_LoImgT())
	return ni
end

// number of images in stack
Function/S f_SplitOptions()

	// globals for package	
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string mStr = "None;"
	string wdf = "root:" + cwdfolder
		
	string rfile = wdf + ":" + f_RootFileName()
	string thfile = rfile + "_th"
	string bgfile = rfile + "_bg"
	
	wave/SDFR=$wdf/Z twave = $thfile
	if (waveexists(twave))
		mStr += "Threshold;"
	endif
	wave/SDFR=$wdf/Z bwave = $bgfile
	if (waveexists(bwave))
		mStr += "Background;"
	endif		
	
	return mStr
end

// current file is stack
Function f_isStack()

	// globals for package	
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string imgFile = "root:" + cwdfolder + ":" + cwfile
	variable rtnv = 0
	
	if (numtype(DimSize($imgFile,2))!=2)
		rtnv = 1
	endif
	
	return rtnv
end

// number of images in stack
Function f_NImagesinStack()

	// globals for package	
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable ni
	string imgFile = "root:" + cwdfolder + ":" + cwfile
	
	ni = DimSize($imgFile,2)
	if (numtype(ni)!=0)
		ni = 0
	endif
	return ni
end

// current plane number being viewed in stack
Function f_PlaneNumber()

	variable pl = 0
	
	if (f_isStack())
		ControlInfo/W=$k_fullpanel setvarSN_TabM
		pl = v_value
	endif
	
	return pl
end

// list of imgT folders
Function/S f_LoImgT()

	DFREF cdf = GetDataFolderDFR()

	SetDataFolder root:
	string lof = f_LoFolders(cstr="imgT_*")
	SetDataFolder cdf
	
	lof = ReplaceString("imgT_",lof,"")
	
	return lof
end

// return the image note for the current display
Function/S f_ImageNoteText()

	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string wname = "root:" + cwdfolder + ":" + cwfile
	
	return (note($wname))
end

Function/WAVE f_ImageSize()

	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	variable xpixels, ypixels
	variable xm, ym, xlm, how
	
	string wname = "root:" + cwdfolder + ":" + cwfile
	xpixels = DimSize($wname,0)
	ypixels = DimSize($wname,1)
	
	make/N=5/FREE rwave
	rwave[3] = xpixels
	rwave[4] = ypixels

	// check for scale for image
	STRUCT S_ProcessVariables spv
	// pixels (no scaling)
	if (Sf_GetProcessVariables(spv)==-1)
		rwave[0] = 0
		rwave[1] = xpixels
		rwave[2] = ypixels
		return rwave
	endif
	
	how = spv.xyhow
	// translate scale
	switch(how)
		case 1:	// pixel size
			rwave[0] = 1
			xm = xpixels*spv.xympixel
			ym = ypixels*spv.xympixel
			xlm = round(log(xm))
			xm /= 10^xlm
			ym /=10^xlm
			xlm += spv.xylmpixel
			break
		case 2:	// image width
			rwave[0] = 2
			xm = spv.xyiwidth
			ym = (ypixels/xpixels)*xm
			xlm = round(log(xm))
			xm /= 10^xlm
			ym /=10^xlm
			xlm += spv.xyliwidth
			break
	endswitch
	rwave[1] = xm*10^xlm
	rwave[2] = ym*10^xlm

	return rwave
end

// return the image size for the current display
Function/S f_ImageSizeText()

	variable xcal = f_ImageSize()[0]
	string rtstr = ""
	
	switch(xcal)
		case 0:		// pixels
			sprintf rtstr, "image size: %3.0f x %3.0f [pixels]", f_ImageSize()[1], f_ImageSize()[2]
			break
		case 1:		// pixels
			sprintf rtstr, "pixel size: %1.3f x %1.3f [m]", f_ImageSize()[1], f_ImageSize()[2]
			break
		case 2:		// image
			sprintf rtstr, "image size: %1.3f x %1.3f [m]", f_ImageSize()[1], f_ImageSize()[2]
			break
	endswitch
	
	return rtstr
end

// return the bit depth of the current image
Function f_ImageBitDepth()

	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable bitd, wtype
	
	string wname = "root:" + cwdfolder + ":" + cwfile
	wtype = WaveType($wname,0)	
	if (wtype & 0x08)
		bitd = 8		// 8 bit
	elseif (wtype & 0x10)
		bitd = 16		// 16 bit
	endif
	
	return bitd
end

// list of folders in a sdfr following a cstr string convention
Function/S f_LoFolders([sdfr,cstr])
	string cstr
	DFREF sdfr
	
	if (!ParamIsDefault(sdfr))
		SetDataFolder sdfr
	endif
	
	string tstr = "", lstr = ""
	variable ic
	do
		tstr = GetIndexedObjName("",4,ic)
		if (strlen(tstr)==0)
			break
		else
			lstr += tstr + ";"
		endif
		ic += 1
	while (1)
	
	if (!ParamIsDefault(cstr))
		lstr = ListMatch(lstr,cstr,";")
	endif
	
	return lstr
end

// image files in a given folder
Function/S f_LoimgF([sfolder])
	string sfolder
	
	string lfiles = ""
	
	if (!ParamIsDefault(sfolder))
		lfiles = "root:" + sfolder
	else
		ControlInfo/W=$k_fullpanel popupfolder_tabM
		lfiles = "root:imgT_" + S_value
	endif
	
	DFREF imgF = $lfiles
	DFREF cdf = GetDataFolderDFR()
	SetDataFolder imgF
	lfiles = ReplaceString("img_",WaveList("img_*",";",""),"")
	SetDataFolder cdf
	
	return lfiles
end

// has scale
Function f_HasLocalScale()
	
	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder

	string wf = "root:" + cwdfolder + ":imgT_processvariables"
	if (DataFolderExists(wf))
		return 1
	else
		return 0
	endif
end

// checks whether the current image is already a contact print storage
Function f_IsContactPrint()

	// global values
	DFREF cpf = $k_fullpackageFolder + ":contactprint"
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable tf=0, ic=0, cplane = f_isStack() ? f_PlaneNumber() : 0
	string cpstr,cpritem
	
	if (f_CountofContactPrints()==0)
		return tf
	endif
	
	cpstr = cwdfolder[5,inf] +"_" + cwfile + "_" + num2str(cplane)
	
	do
		cpritem = GetIndexedObjNameDFR(cpf,3,ic)
		if (strlen(cpritem)==0)
			break
		endif
		if (cmpstr(cpstr,cpritem)==0)
			tf = 1
			break
		endif
		ic += 1
	while(1)

	return tf
end

// counts the number of contact prints stored
Function f_CountofContactPrints()

	// global values
	DFREF cpf = $k_fullpackageFolder + ":contactprint"
	
	variable cnt = 0
	
	if (DataFolderExists(k_fullpackageFolder + ":contactprint"))
		cnt = CountObjectsDFR(cpf,3)
	else
		cnt = -1
	endif
	
	return cnt
end

// has marquee or locked marquee
Function f_HasRoI()

	STRUCT S_MarqueeCoordinates mc
	Sf_GetMCCoordinates(mc)
	if (mc.hasmarquee)
		return 1
	elseif (mc.hasdrawing)
		return 2
	endif
	
	return 0
end

// what is the current image?
Function/S f_CurrentImage()
	
	string cImage = ImageNameList(k_imgDisplay,"")
	cImage = ListMatch(cImage,"!RP_*")
	cImage = StringFromList(0,SortList(cImage))
	return cImage
end