﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Static StrConstant k_fullpackageFolder = "root:Packages:imgT"
Static StrConstant k_fullpanel = "imgT_display#imgT_panel"

// uncomment to debug
//#define DEBUG

#pragma hide = 1

// ***
// STRUCTURES

// structure to collect load instructions
Structure S_LoadSettings
	variable source
	variable gray
	variable red
	variable green
	variable blue
	variable howmany
	variable startimage
	variable stepimage
	variable endimage
	variable startindex
	variable stepindex
	variable asstack
EndStructure

// populate the structure
Function Sf_GetLoadSettings(ls)
	STRUCT S_LoadSettings &ls
	
	ControlInfo/W=$k_fullpanel checkgsource_tab0
	ls.source = v_value
	ControlInfo/W=$k_fullpanel checkgred_tab0
	ls.red = v_value
	ControlInfo/W=$k_fullpanel checkggreen_tab0
	ls.green = v_value
	ControlInfo/W=$k_fullpanel checkgblue_tab0
	ls.blue = v_value
	ControlInfo/W=$k_fullpanel checkggray_tab0
	ls.gray = v_value
	
	ls.howmany = ls.source + ls.gray + ls.red + ls.green + ls.blue

	ControlInfo/W=$k_fullpanel startimg_tab0
	ls.startimage = v_value
	ControlInfo/W=$k_fullpanel endimg_tab0
	ls.endimage = v_value
	ControlInfo/W=$k_fullpanel stepimg_tab0
	ls.stepimage = v_value
	ControlInfo/W=$k_fullpanel startind_tab0
	ls.startindex = v_value
	ControlInfo/W=$k_fullpanel stepind_tab0
	ls.stepindex = v_value
	
	ControlInfo/W=$k_fullpanel checkasstack_tab0
	ls.asstack = v_value
	
	return 0
end

// draw tab0 - load
Function disp_Tab0Draw(pwidth,pheight,ptabpos)
	variable pwidth, pheight, ptabpos

	variable tvoffset = ptabpos+25
	
	TabControl tab_main, value=0, userdata(ptab)="0"
	
	TitleBox load_tab0,pos={12,tvoffset},size={84,22},title="Load TIFF(s)"
	TitleBox load_tab0,fSize=18,frame=0,fStyle=1,disable=0

	tvoffset += 25
	
	PopupMenu popupload_tab0,pos={22,tvoffset},size={113,23},title="What"
	PopupMenu popupload_tab0,mode=1,popvalue="One File",value= #"\"One File;Many Files;Entire Folder;Image Stack;\""
	PopupMenu popupload_tab0,fSize=14,disable=0,proc=X_PopMenuProc

	tvoffset += 25
	
	SetVariable startimg_tab0, pos={25,tvoffset},size={120,16},title="Start At"
	SetVariable startimg_tab0, fSize=12,value=_NUM:1, limits={0,inf,1}, disable=2
	SetVariable endimg_tab0, pos={25+130,tvoffset},size={120,16},title="Load Only"
	SetVariable endimg_tab0, fSize=12,value=_NUM:inf, limits={1,inf,1}, disable=2
	SetVariable stepimg_tab0, pos={25+260,tvoffset},size={120,16},title="Step By"
	SetVariable stepimg_tab0, fSize=12,value=_NUM:1, limits={1,inf,1}, disable=2
	
	tvoffset += 25
	
	SetVariable startind_tab0, pos={25,tvoffset},size={120,16},title="Start Label"
	SetVariable startind_tab0, fSize=12,value=_NUM:0, limits={0,inf,1}, disable=2
	SetVariable stepind_tab0, pos={25+130,tvoffset},size={120,16},title="Step Label"
	SetVariable stepind_tab0, fSize=12,value=_NUM:1, limits={1,inf,1}, disable=2
	CheckBox checkasstack_tab0, pos={pwidth-120,tvoffset}, fSize=10, title="store as stack"
	CheckBox checkasstack_tab0, value=0, disable=2
	CheckBox checkasstack_tab0, help={"Load N>4 files as stack or load a stack as a stack"}
	
	tvoffset +=25
	
	CheckBox checkgsource_tab0,pos={35,tvoffset},size={76,16},title="keep source"
	CheckBox checkgsource_tab0,fSize=10,value=1
	
	CheckBox checkgred_tab0,pos={35+100,tvoffset},size={102,16},title="extract red image"
	CheckBox checkgred_tab0,fSize=10,value=0
	CheckBox checkggreen_tab0,pos={35+100,tvoffset+18},size={114,16},title="extract green image"
	CheckBox checkggreen_tab0,fSize=10,value=0
	CheckBox checkgblue_tab0,pos={35+100,tvoffset+36},size={107,16},title="extract blue image"
	CheckBox checkgblue_tab0,fSize=10,value=0
	
	CheckBox checkgGray_tab0,pos={35+250,tvoffset},size={109,16},title="generate grayscale"
	CheckBox checkgGray_tab0,fSize=10,value=0
	
	tvoffset += 35
	
	Button buttonLoad_tab0,pos={300,tvoffset},size={80,25},proc=X_ButtonProc,title="Load"
	Button buttonLoad_tab0,fSize=18,disable=0

	return 0
end


// load a single TIFF image
Function T0_LoadOneTIFFImg()
	
	// get load settings
	STRUCT S_LoadSettings ls
	Sf_GetLoadSettings(ls)

	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	SetDataFolder root:
	
	// select file	
	string fFilter = "TIF Images ONLY:.tif,.tiff;"
	variable refNum
	Open/D/R/F=fFilter/M="Select ONE TIFF image" refNum
	if (strlen(S_filename)==0)
		return -1
	endif
	
	// get path and file name
	string fPath, fFullName, fnsuffix, fnimg
	fPath = ParseFilePath(1,S_filename,":",1,0)
	NewPath/O/Q/Z imgPath, fPath
	fFullName = ParseFilePath(0,S_filename,":",1,0)
	
	// load the image file
	T0do_loadfile(fFullName,ls)
	
	SetDataFolder root:
	
	fFilter = f_DateTimeStamp() + " -> Loaded one TIFF image file from " + fPath
	fFilter += "\r\tFile: " + fFullName
	print fFilter
	
	return 0
end

// load a set of TIFF images
Function T0_LoadMultipleTIFFImgs()
	
	// get load settings
	STRUCT S_LoadSettings ls
	Sf_GetLoadSettings(ls)

	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	string fFilter = "TIF Images ONLY:.tif,.tiff;", pstr
	string fPath, fFullName, theFile, thefList = "", fnsuffix, fnimg	
	string FolderNameList = ""
	variable refNum, ic, nf
	
	// select files
	Open/MULT=1/D/R/F=fFilter/M="Select multiple TIFF images" refNum
	if (strlen(S_filename)==0)
		return -1
	endif
	
	// get path and file names	
	theFile = StringFromList(0,S_filename,"\r")
	fPath = ParseFilePath(1,theFile,":",1,0)
	//theFirstFile = ParseFilePath(0,theFile,":",1,0)
	NewPath/O/Q/Z imgPath, fPath
	
	SetDataFolder root:

	// load multiple files as stack			
	nf = ItemsInLIst(S_filename,"\r")	
	if ((ls.asstack == 1) && (nf > 4))
		for (ic=0;ic<nf;ic+=1)
			theFile = StringFromList(ic,S_filename,"\r")
			thefList += ParseFilePath(0,theFile,":",1,0) + ";"
		endfor
		FolderNameList = T0do_loadfas(thefList,ls)
	else
		// loop through to load files
		for (ic=0;ic<nf;ic+=1)
			theFile = StringFromList(ic,S_filename,"\r")
			fFullName = ParseFilePath(0,theFile,":",1,0)
			FolderNameList += T0do_loadfile(fFullName,ls)
			thefList += fFullName + ";"
		endfor
	endif
	
	SetDataFolder root:
	
	pstr = f_DateTimeStamp() + " -> Loaded multiple TIFF image files from " + fPath
	pstr += "\r\tFiles: " + thefList
	pstr += "\r\tInto Folders: " + FolderNameList
	print pstr
		
	return 0
end

// load a folder of TIFF images
Function T0_LoadaFolder()
	
	// get load settings
	STRUCT S_LoadSettings ls
	Sf_GetLoadSettings(ls)

	variable ic, nf
	string flist, fPath, theFile, thefList, fFullName, FolderNameList = ""
	string pstr
	
	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	SetDataFolder root:
	
	// select folder
	NewPath/O/Q/M="Select a folder with the TIF images"/Z imgPath
	if (v_flag!=0)
		return -1
	endif
	
	// load the folder
	PathInfo imgPath
	fPath = ParseFilePath(0,S_path,":",1,0)
	flist = IndexedFile(imgPath,-1,".tif")

	nf = ItemsInList(flist,";")
	
	// load folder as stack			
	if ((ls.asstack == 1) && (nf > 4))
		FolderNameList = T0do_loadfas(flist,ls)
	else
		// loop through to load files
		for (ic=0;ic<nf;ic+=1)
			theFile = StringFromList(ic,flist)
			FolderNameList += T0do_loadfile(fFullName,ls) + ";"
		endfor
	endif

	SetDataFolder root:
	
	pstr = f_DateTimeStamp() + " -> Loaded a folder of TIFF image files from " + fPath
	pstr += "\r\tFiles: " + flist
	pstr += "\r\tInto Folders: " + FolderNameList
	print pstr

	return 0
end

// load a stack of TIFF images
Function T0_LoadStackTIFFImgs()
	
	// get load settings
	STRUCT S_LoadSettings ls
	Sf_GetLoadSettings(ls)

	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	SetDataFolder root:
	
	string fFilter = "TIF Images ONLY:.tif,.tiff;",pstr
	variable refNum

	// select files
	Open/MULT=0/D/R/F=fFilter/M="Select a TIFF image stack" refNum
	if (strlen(S_filename)==0)
		return -1
	endif
	
	string fPath, fFullName, theFile, theFirstFile, fnsuffix, fnimg
	string fSlicePrefix, fSliceName, FolderNameList=""
	variable ic, no, nf, ns, nmax, dn
	
	// get path and file names	
	theFile = S_filename
	fPath = ParseFilePath(1,theFile,":",1,0)
	fFullName = ParseFilePath(0,theFile,":",1,0)
	fSlicePrefix = ParseFilePath(3,theFile,":",0,0)
	NewPath/O/Q/Z imgPath, fPath
	
	// get number of images in stack
	KillDataFolder/Z imgTtmp
	NewDataFolder/O/S imgTtmp
	ImageLoad/Q/C=0/T=TIFF/RTIO/P=imgPath theFile
	nmax = V_numImages
	
#ifdef DEBUG
	SetDataFolder ::
#else
	KillDataFolder :
#endif
	
	if (ls.asstack==1)
		// get each file and append to stack
		FolderNameList = T0do_loadsas(fFullName,ls,stnum=no,digits=dn)
	else
		// set the loop parameters
		no = ls.startimage - 1
		ns = ls.stepimage
		
		if (numtype(ls.endimage)!=0)
			nf = nmax
		else
			nf = ns*ls.endimage
		endif
	
		// set the digits for sequencing image names
		dn = ls.startindex + nf*ls.stepindex
		dn = round(log(dn))
		// loop through to load images from stack
		for (ic=no;ic<nf;ic+=ns)
			FolderNameList += T0do_loadfile(fFullName,ls,stnum=ic,digits=dn) + ";"
		endfor
	endif
	
	pstr = f_DateTimeStamp() + " -> Loaded a TIFF image stack from " + fPath
	pstr += "\r\tFile: " + fFullName
	pstr += "\r\tInto Folder(s): " + FolderNameList
	print pstr
	
	return 0
end

// load a file
// fname - file name; ls - load settings
// stnum - start number, digits - sequence digits
// returns folder name
Function/S T0do_loadfile(fname,ls,[stnum,digits])
	string fname
	STRUCT S_LoadSettings &ls
	variable stnum, digits

	string fnprefix, newFldrName, imgname, fs
	
	// create and move to folder
	DFREF cdf = GetDataFolderDFR()
	fnprefix = StringFromList(0,fname,".")
	if (!ParamIsDefault(stnum))
		fs =  fnprefix + "_%0" + num2str(digits) + "d"
		sprintf fnprefix fs, (ls.startindex + stnum*ls.stepindex)
	endif
	newFldrName = CreateImageFolder(fnprefix)
	DFREF imgDF = root:$newFldrName

	SetDataFolder imgDF
		
	// load the image file
	
	if (ParamIsDefault(stnum))
		ImageLoad/RAT/P=imgPath/N=source/Q fname
	else
		ImageLoad/RAT/P=imgPath/S=(stnum)/C=1/Q fname
	endif
	
	// clean up file name
	imgname = StringFromList(0,s_wavenames)
	wave source = $imgname
	rename source img_source
	wave img_source
	
	// generate red
	if (ls.red)
		ImageTransform/P=0 getPlane img_source
		wave M_ImagePlane
		rename M_ImagePlane img_red
	endif
	
	// generate green
	if (ls.green)
		ImageTransform/P=1 getPlane img_source
		wave M_ImagePlane
		rename M_ImagePlane img_green
	endif
	
	// generate blue
	if (ls.blue)
		ImageTransform/P=2 getPlane img_source
		wave M_ImagePlane
		rename M_ImagePlane img_blue
	endif
	
	// generate gray
	if (ls.gray)
		ImageTransform rgb2gray img_source
		wave M_RGB2Gray
		rename M_RGB2Gray img_gray
	endif
	
	// keep source?
	if (!ls.source)
		killwaves/Z img_source
	endif
	
	// store the load parameters
	NewDataFolder/O/S imgT_loadparams
	string/G sDateLoaded = f_DateTimeStamp()
	variable/G imgred, imggreen, imgblue, imgsource, imggray	
	imgred = ls.red
	imggreen = ls.green
	imgblue = ls.blue
	imggray = ls.gray
	imgsource = ls.source

	SetDataFolder cdf
	return newFldrName
end

// load list of files as a stack
// fname - file name list; ls - load settings
// stnum - start number, digits - sequence digits
// returns folder name
Function/S T0do_loadfas(flist,ls,[stnum,digits])
	string flist
	STRUCT S_LoadSettings &ls
	variable stnum, digits

	string fnprefix, newFldrName, imgname, fs, fname
	variable ic, nChunks
	
	// create and move to folder
	DFREF cdf = GetDataFolderDFR()

	fnprefix = StringFromList(0,flist,".")
	if (!ParamIsDefault(stnum))
		fs =  fnprefix + "_%0" + num2str(digits) + "d_stack"
		sprintf fnprefix fs, ls.startindex
	endif
	newFldrName = CreateImageFolder(fnprefix)
	DFREF imgDF = root:$newFldrName

	SetDataFolder imgDF

	// load the first file and set the file to load images
	nChunks = ItemsInList(flist)
	fname = StringFromList(0,flist)
	ImageLoad/RTIO/P=imgPath/Q fname
	ImageLoad/P=imgPath/Q/N=imgrawsource fname
	wave imgrawsource
	Redimension/N=(-1,-1,-1,1) imgrawsource
	
	// load each file into a stack
	for(ic=1;ic<nChunks;ic+=1)
		fname = StringFromList(ic,flist)
		ImageLoad/RTIO/P=imgPath/Q fname
		ImageLoad/P=imgPath/Q/N=imgFile fname
		wave imgFile
		ImageTransform/D=imgFile/CHIX=(ic) insertChunk imgrawsource
		//imgrawsource[][][][ic] = imgFile[p][q][r]
		killwaves/Z imgFile
	endfor
	
	// make the source to tmp
	Duplicate/O imgrawsource imgtmp
	wave imgtmp
	Redimension/E=1/N=(-1,-1,3*nChunks) imgtmp
	
	nChunks = nChunks*3 - 1
	// get components
	if (ls.red)
		MatrixOP/O img_red_st = imgtmp[][][0,nChunks,3]
		wave img_red_st
	endif
	if (ls.green)
		MatrixOP/O img_green_st = imgtmp[][][1,nChunks,3]
		wave img_green_st
	endif
	if (ls.blue)
		MatrixOP/O img_blue_st = imgtmp[][][2,nChunks,3]
		wave img_blue_st
	endif
	if (ls.gray)
		ImageTransform rgb2gray imgrawsource
		wave M_RGB2Gray
		MatrixOP/O img_gray_st = M_RGB2gray[][][0,nChunks,3]		
	endif
	// keep source?
	if (!ls.source)
		killwaves/Z imgrawsource, imgtmp
	else
		killwaves/Z imgrawsource
		rename imgtmp imgrawsource
	endif
	
	// store the load parameters
	NewDataFolder/O/S imgT_loadparams
	string/G sDateLoaded = f_DateTimeStamp()
	variable/G imgred, imggreen, imgblue, imgsource, imggray, imgstack
	imgred = ls.red
	imggreen = ls.green
	imgblue = ls.blue
	imggray = ls.gray
	imgsource = ls.source
	imgstack = ls.asstack
	
	SetDataFolder cdf
	return newFldrName
end

// load a stack as a stack
// fname - file name; ls - load settings
// stnum - start number, digits - sequence digits
// returns folder name
Function/S T0do_loadsas(fname,ls,[stnum,digits])
	string fname
	STRUCT S_LoadSettings &ls
	variable stnum, digits

	string fnprefix, newFldrName, imgname, fs
	variable ic, jc, no, ns, nload, nstep, nchunks
	
	// create and move to folder
	DFREF cdf = GetDataFolderDFR()

	fnprefix = StringFromList(0,fname,".")
	if (!ParamIsDefault(stnum))
		fs =  fnprefix + "_%0" + num2str(digits) + "d_stack"
		sprintf fnprefix fs, ls.startindex
	endif
	newFldrName = CreateImageFolder(fnprefix)
	DFREF imgDF = root:$newFldrName

	SetDataFolder imgDF

	// set up the image loading parameters
	no = ls.startimage
	ns = ls.stepimage
	nload = ls.endimage*ns
	
	ImageLoad/RTIO/P=imgPath/Q fname
	ImageLoad/P=imgPath/S=(nload)/C=(-1)/Q/N=imgrawsource fname
	wave imgrawsource
	nChunks = DimSize(imgrawsource,3)
#ifdef DEBUG
	print "Want to load and actual load: ", nload, nChunks
#endif
	if (ls.endimage == inf)
		nload = nChunks
	endif

	Duplicate/O imgrawsource imgtmp
	wave imgtmp
	Redimension/E=1/N=(-1,-1,3*nChunks) imgtmp

	ns *= 3
	nChunks = nload*ns - 1
	
	// get components
	if (ls.red)
		MatrixOP/O img_red_st = imgtmp[][][0,nChunks,ns]
		wave img_red_st
	endif
	if (ls.green)
		MatrixOP/O img_green_st = imgtmp[][][1,nChunks,ns]
		wave img_green_st
	endif
	if (ls.blue)
		MatrixOP/O img_blue_st = imgtmp[][][2,nChunks,ns]
		wave img_blue_st
	endif
	if (ls.gray)
		ImageTransform rgb2gray imgrawsource
		wave M_RGB2Gray
		MatrixOP/O img_gray_st = M_RGB2gray[][][0,nChunks,ns]		
	endif
	// keep source?
	if (!ls.source)
		killwaves/Z imgrawsource, imgtmp
	else
		killwaves/Z imgrawsource
		rename imgtmp imgrawsource
	endif
	
	// store the load parameters
	NewDataFolder/O/S imgT_loadparams
	string/G sDateLoaded = f_DateTimeStamp()
	variable/G imgred, imggreen, imgblue, imgsource, imggray, imgstack
	imgred = ls.red
	imggreen = ls.green
	imgblue = ls.blue
	imggray = ls.gray
	imgsource = ls.source
	imgstack = ls.asstack
	
	SetDataFolder cdf
	return newFldrName
end
