﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Static StrConstant k_fullpackageFolder = "root:Packages:imgT"

// uncomment to debug
//#define DEBUG

#ifndef DEBUG
#pragma hide=1
#endif

// draw tab2 - process
Function disp_Tab2Draw(pwidth,pheight, ptabpos)
	variable pwidth, pheight, ptabpos

	variable tvoffset = ptabpos + 25
	
	string qu = "\""
	string tmodes = qu + "Manual;Iterative;Bimodal;Adaptive;Fuzzy;Fuzzy+;Cluster;Otsu;" + qu
	
	TabControl tab_main, value=2, userdata(ptab)="2"
	
	TitleBox threshold_tab2,pos={12,tvoffset},size={84,22},title="Threshold"
	TitleBox threshold_tab2,fSize=18,frame=0,fStyle=1,disable=1
	
	tvoffset += 25
	
	PopupMenu popupThresMethod_tab2,pos={12,tvoffset},size={124,23},title="Method",fSize=14
	PopupMenu popupThresMethod_tab2,mode=1,popvalue="Manual",value=#tmodes, disable=1, proc=X_PopMenuProc

	SetVariable setvarThresLevel_tab2,pos={150,tvoffset},size={100,18},title="Level",fSize=12
	SetVariable setvarThresLevel_tab2,limits={1,inf,1},value=_NUM:0, disable=1, proc=X_SetVarProc
	
	Button buttonDoThreshold_tab2,pos={pwidth-85,tvoffset-2},size={75,25},proc=X_ButtonProc,title="Apply"
	Button buttonDoThreshold_tab2,fSize=14,disable=1
	
	tvoffset += 25
	
	Checkbox checkOTPlane_tab2,pos={pwidth-110,tvoffset},size={80,20},title="to this plane only",fSize=10
	Checkbox checkOTPlane_tab2,value=0,disable=1

	return 0
end

// do threshold of image
Function T2_DoThreshold(method, level, [plane, toall])
	variable method, level, plane, toall

	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string wdf = "root:" + cwdfolder
	string sfile, wfile, lstr
	
	variable nimgs, thexists = 0, onpl = 0, isstack = 0
	
	// avoid thresholding a threshold
	// set existence of threshold
	if (f_isThreshold())
		sfile = ReplaceString("_th",cwfile,"")
		wfile = cwfile
		thexists = 1
	else
		if (f_ThresholdExists()==1)
			thexists = 1
			wfile = cwfile + "_th"
		else
			thexists = 0
		endif
		sfile = cwfile
	endif
	lstr = sfile[4,inf] + "_thlevels"
	
	// set the source file
	wave/SDFR=$wdf simage = $sfile
	
	DFREF cdf = GetDataFolderDFR()	
	SetDataFolder wdf
	
	nimgs = DimSize($sfile,2)
	if (nimgs>0)
		isstack = 1
		if (ParamIsDefault(plane))
			plane = -1
		else
			onpl = 1
		endif
	else
		plane = -1
	endif

#ifdef DEBUG
	print "doing threshold: ", sfile, wfile, lstr, plane, level, method
#endif
	
	switch(method)
		case 0:		//manual
			ImageThreshold/P=(plane)/M=0/T=(level)/Q simage
			v_threshold = level
			break
		case 1:		// iterative
			ImageThreshold/P=(plane)/M=1/Q simage
			break
		case 2:		// bimodal
			ImageThreshold/P=(plane)/M=2/Q simage
			break
		case 3:		// adaptive
			try
				ImageThreshold/P=(plane)/M=3/Q simage
			catch
				break
			endtry
			break
		case 4:		// fuzzy
			ImageThreshold/P=(plane)/M=4/Q simage
			break
		case 5:		// fuzzy+
			ImageThreshold/P=(plane)/M=5/Q simage
			break
		case 6:		// cluster
			ImageThreshold/P=(plane)/M=6/Q simage
			break
		case 7:		// Otsu
			ImageThreshold/P=(plane)/M=7/Q simage
			break
	endswitch

	wave M_ImageThresh

	switch(thexists)
		case 0:		// no prior threshold existed
			wfile = cwfile + "_th"
			duplicate $cwfile $wfile
			wave/SDFR=$wdf tw = $wfile
			if (isstack && onpl)
				tw[][][plane] = M_ImageThresh[p][q]
				nimgs = f_NImagesinStack()
				make/N=(nimgs)/O/D $lstr
				wave tlevels = $lstr
				tlevels[plane] = v_threshold
			else
				MatrixOP/O tw = M_ImageThresh
				if (isstack)
					nimgs = f_NImagesinStack()
					make/N=(nimgs)/O $lstr
				else
					make/N=1 $lstr
				endif
				wave tlevels = $lstr
				tlevels = v_threshold
			endif
			break
		case 1:		// threshold already existed
//			wfile = wfile + "_th"
			wave/SDFR=$wdf tlevels = $lstr
			if (waveexists(tlevels)==0)
				if (isstack)
					nimgs = f_NImagesinStack()
					make/N=(nimgs)/O $lstr
				else
					make/N=1 $lstr
				endif
			endif
			wave/SDFR=$wdf tw = $wfile
			if (isstack && onpl)
				tw[][][plane] = M_ImageThresh[p][q]
				nimgs = f_NImagesinStack()
				wave tlevels = $lstr
				tlevels[plane] = v_threshold
			else
				MatrixOP/O tw = M_ImageThresh
				wave tlevels = $lstr
				tlevels = v_threshold
			endif			
			break
	endswitch

#ifndef DEBUG
	killwaves/Z M_ImageThresh
#endif

	SetDataFolder cdf
	
	return 0
end
